; canon-random.lisp - make a random melody and play that against itself
(require :asdf)
(asdf:load-system :smolmidi)   ; https://thrig.me/src/smolmidi.git
(block nil (setq *random-state* (make-random-state t)) (return))

(let ((pitches '(57 59 60 62 64 65 67 69)))
  (defun random-pitch ()
    (nth (random (list-length pitches)) pitches)))

(defun play (track duration pitch &key (velocity 96) (offset 0))
  (smolmidi:note-on track offset pitch velocity)
  (smolmidi:note-off track duration pitch 0))

(let (pitch-list)
  (defun melody (&key (length 16) (offset 0) (duration 96) (transpose 0))
    (unless pitch-list
      (setf pitch-list (loop repeat length collect (random-pitch)))
      (format t "~&~a~&" pitch-list))
    (let ((track (smolmidi:new-track)))
      (play track duration (+ transpose (first pitch-list))
            :offset (* offset duration))
      (loop for pitch in (rest pitch-list) do
            (play track duration (+ transpose pitch)))
      track)))

(smolmidi:write-midi-file
  "out.midi" (list (melody)
                   (melody :offset 4 :transpose 12)))